package org.apache.bcel.generic;

import java.io.IOException;
import java.io.DataOutputStream;

public class JSR extends JsrInstruction implements VariableLengthInstruction
{
    JSR() {
    }
    
    public JSR(final InstructionHandle target) {
        super((short)168, target);
    }
    
    @Override
    public void accept(final Visitor v) {
        v.visitStackProducer(this);
        v.visitVariableLengthInstruction(this);
        v.visitBranchInstruction(this);
        v.visitJsrInstruction(this);
        v.visitJSR(this);
    }
    
    @Override
    public void dump(final DataOutputStream out) throws IOException {
        super.setIndex(this.getTargetOffset());
        if (super.getOpcode() == 168) {
            super.dump(out);
        }
        else {
            super.setIndex(this.getTargetOffset());
            out.writeByte(super.getOpcode());
            out.writeInt(super.getIndex());
        }
    }
    
    @Override
    protected int updatePosition(final int offset, final int maxOffset) {
        final int i = this.getTargetOffset();
        this.setPosition(this.getPosition() + offset);
        if (Math.abs(i) >= 32767 - maxOffset) {
            super.setOpcode((short)201);
            final short oldLength = (short)super.getLength();
            super.setLength(5);
            return super.getLength() - oldLength;
        }
        return 0;
    }
}
